# "File namer" : ChVote file-based standards
[![pipeline status](https://gitlab.com/chvote2/shared-libraries/file-namer/badges/master/pipeline.svg)](https://gitlab.com/chvote2/shared-libraries/file-namer/commits/master)
[![Quality Gate Status](https://sonarcloud.io/api/project_badges/measure?project=file-namer&metric=alert_status)](https://sonarcloud.io/dashboard?id=file-namer)

This project contains utility tools for standardizing the file-based communication throughout the ChVote platform.

> **_Note about naming :_**  
> _This library's name has been decided when its unique goal was to normalize the naming of the platform's files.
> Its scope has grown since, but the name remained. We really should find a better one..._

# Usage

## 1. Standard, pattern-based, filenames generation

This project contains components for generating a file name following a pattern depending on the file's type.

The `FileNamer` static utility provides naming for multiple file types, via dedicated static methods :
```java
  // Archive of eCH-0228 files (decrypted voting material to be printed and sent to voters)
  String archiveName = FileNamer.ech228Archive("test operation", "printer 1", LocalDateTime.now());

  // Voting cards : eCH-0228
  String filename = FileNamer.ech228File("test operation", "printer 1", LocalDateTime.now());
  
  // "Printer file" from a lot definition, ie for a business group (TEST_NOT_PRINTABLE, TEST_PRINTABLE, PRINTER, CONTROL)
  String filename = FileNamer.lotPrinterFile(PrintingLotType.CONTROL, "test operation", "control cards", "printer 1", LocalDateTime.now());
  
  // Voter report
  String reportname = FileNamer.votersReport("test operation", "Geneva 1", importSource.getDate());
  String consolidatedReportName = FileNamer.consolidatedVotersReport("test operation", importSource.getDate());
  
  // Result files : eCH-0110 and eCH-0222
  String filename = FileNamer.ech110File("test operation", LocalDateTime.now());
  String filename = FileNamer.ech222File("test operation", LocalDateTime.now());
```

Three additional file types are handled in a different way : a value object allows to either format the name from
known metadata, or retrieve those metadata by parsing a name :
```java
  // EPF archive files (Encrypted Printer File)
  String fileName = new EpfFileName("printer 1", 1, "0-100").toString();
  EpfFileName vo = EpfFileName.parse(fileName);
  assertThat(vo.getPrintingAuthorityName(), isEqualTo("printer 1"));
  assertThat(vo.getControlComponentIndex(), isEqualTo(1));
  assertThat(vo.getQualifier(), isEqualTo("0-100"));
  
  // ..and in the same way, printer- and tally-archive file names
  PrinterArchiveFileName paFilename = new PrinterArchiveFileName("my printer", "an operation", creationDate);
  TallyArchiveFileName taFilename = new TallyArchiveFileName("some operation", creationDate);
```


## 2. Archive files contract

The ChVote platform generates archive files to be handled by offline tools, where very specific data is expected to be
found. In a way, this could be considered a file-based machine-to-machine communication channel, and we found practical
to define that expected content once, with both ways of creating and reading such archives in a single place.

  - _"printer archives"_ are generated by the **PACT** and contain the encrypted voting material. They are expected to
    be decrypted by **U-Print** at the printer's place.
  - _"tally archives"_ are generated by the **PACT** and contain the protocol-generated results as obtained from the control
    components. Decrypted results and proofs are expected to be created by the electoral authority using **U-Count**.

### Printer archives
```java
  // Create a printer archive :
  Path outputDir = Paths.get("/where/to/create/my/archive");
  PrinterArchiveMaker archiveMaker = new PrinterArchiveMaker("printer 1").withOperationName("test operation");
  Path archive = archiveMaker.withVotersReferenceSource(Paths.get("voters.xml"))
                             .withPublicParametersSource(Paths.get("my-public-params.json"))
                             .withElectionSetSource(Paths.get("my-election-set.json"))
                             .withOperationConfigurationSource(Paths.get("my-op-conf.json"))
                             .withElectionConfigurationsSource(Paths.get("my-election-conf.json"))
                             .addOperationReferenceSource(Paths.get("xx_operation.xml"))
                             .addPrivateCredentialsSource(Paths.get("xx_printer-file.epf"))
                             .make(outputDir);
  
  // .. then read it :
  PrinterArchiveReader reader = PrinterArchiveReader.readFrom(archive);
  assertThat(reader.getPrinterName(), isEqualTo("printer 1"));
  assertThat(reader.getOperationName(), isEqualTo("test operation"));
  
  assertThat(reader.getPublicParameters(), hasSameContentAs(Paths.get("my-public-params.json")));
  // etc.
```

### Tally archives
```java
  // Create a tally archive :
  Path outputDir = Paths.get("/where/to/create/my/archive");
  TallyArchiveMaker archiveMaker = new TallyArchiveMaker("test operation");
  Path archive = archiveMaker.withBallotsSource(Paths.get("my-test-ballots.json"))
                             .withConfirmationsSource(Paths.get("my-test-confirmations.json"))
                             .withCountingCirclesSource(Paths.get("my-test-counting-circles.json"))
                             .withElectionSetForVerificationSource(Paths.get("my-test-election-set-for-verification.json"))
                             .withGeneratorsSource(Paths.get("my-test-generators.json"))
                             .withPartialDecryptionProofsSource(Paths.get("my-test-partial-decryption-proofs.json"))
                             .withPartialDecryptionsSource(Paths.get("my-test-partial-decryptions.json"))
                             .withPrimesSource(Paths.get("my-test-primes.json"))
                             .withPublicCredentialsSource(Paths.get("my-test-public-credentials.json"))
                             .withPublicKeyPartsSource(Paths.get("my-test-public-key-parts.json"))
                             .withPublicParametersSource(Paths.get("my-test-public-parameters.json"))
                             .withShuffleProofsSource(Paths.get("my-test-shuffle-proofs.json"))
                             .withShufflesSource(Paths.get("my-test-shuffles.json"))
                             .addOperationReferenceSource(Paths.get("xx_operation.xml"))
                             .make(outputDir);
  
  // .. then read it :
  TallyArchiveReader reader = TallyArchiveReader.readFrom(archive);
  assertThat(reader.getOperationName(), isEqualTo("test operation"));
  
  assertThat(reader.getShuffleProofsSource(), hasSameContentAs(Paths.get("my-test-shuffle-proofs.json")));
  // etc.
```

# Building

## Pre-requisites

* JDK 8
* Maven

## Build steps

Build the library is as trivial as a mere maven install :
```bash
mvn clean install
```

# Contributing
See [CONTRIBUTING.md](https://gitlab.com/chvote2/documentation/chvote-docs/blob/master/CONTRIBUTING.md)

# License
This library is Open Source software, released under the [Affero General Public License 3.0](https://gitlab.com/chvote2/shared-libraries/file-namer/blob/master/LICENSE) 
license.